package robotarm_profile.service.acceptor;

import org.robotservices.custom_profile.lib.common.util.XMLUtil;
import org.robotservices.custom_profile.lib.service.acceptor.AcceptorCustomProfileBase;
import org.robotservices.custom_profile.lib.service.util.ClassUtil;
import org.robotservices.schemas.v02.common_profile.RetValue;

import robotarm_profile.common.Robotarm_profile_end_profile;
import robotarm_profile.common.Robotarm_profile_start_profile;

public class RobotarmProfile extends AcceptorCustomProfileBase {

	private IRobotarm_profile robotArmProfileImpl = null;

	/**
	 * CLtoSV
	 * @param xml
	 * @return
	 */
	public String startProfile(String xml) {
		//TODO XMLをもとに戻す
		@SuppressWarnings("unused")
		Robotarm_profile_start_profile robotarm_profile_start_profile = XMLUtil.unmarshal(xml, Robotarm_profile_start_profile.class);
		//ここからさらにディスパッチする
		//TODO 設定ファイル？
		this.robotArmProfileImpl = ClassUtil.getCustomProfileImple("RobotarmProfileImple");

		RetValue retValue = robotArmProfileImpl.startProfile(this.getConvId());
		String returnXml = XMLUtil.marshal(retValue);

		return returnXml;
	}

	/**
	 * CLtoSV
	 * @param xml
	 * @return
	 */
	public String endProfile(String xml) {
		@SuppressWarnings("unused")
		Robotarm_profile_end_profile robotarm_profile_end_profile = XMLUtil.unmarshal(xml, Robotarm_profile_end_profile.class);
		//インスタンスは使いまわす

		RetValue retValue = this.robotArmProfileImpl.endProfile(this.getConvId());
		String returnXml = XMLUtil.marshal(retValue);

		return returnXml;

	}


}